<?php

namespace STM\Person\Position;

use STM\StmFactory;

/**
 * Test class for PersonPosition.
 * Generated by PHPUnit on 2012-03-28 at 12:44:23.
 * @group person
 */
class PersonPositionTest extends \PHPUnit_Framework_TestCase {

    private $all_positions;

    protected function setUp() {
        $this->all_positions = StmFactory::find()->PersonPosition->findAll();
    }

    public function testFind_all() {
        parent::assertTrue(is_array($this->all_positions));
        foreach ($this->all_positions as $position) {            
            parent::assertInstanceOf('\STM\Person\Position\PersonPosition', $position);
        }
    }

    public function testfindById() {
        foreach ($this->all_positions as $position) {            
            parent::assertInstanceOf('\STM\Person\Position\PersonPosition', 
                    StmFactory::find()->PersonPosition->findById($position->getId()));
        }
        parent::assertFalse(StmFactory::find()->PersonPosition->findById(' or 1 = 1'));
        parent::assertFalse(StmFactory::find()->PersonPosition->findById(null));
    }

    public function testCreate() {
        parent::markTestSkipped('test in PersonPositionValidatorTest::testCheck_create');
    }

    public function testExists_position() {
        foreach ($this->all_positions as $position) {            
            $name = $position->__toString();
            // case-INsensitive
            parent::assertTrue(PersonPosition::exists($name));
            parent::assertTrue(PersonPosition::exists(mb_strtolower($name, 'UTF-8')));
            parent::assertTrue(PersonPosition::exists(mb_strtoupper($name, 'UTF-8')));
            parent::assertFalse(PersonPosition::exists('_*A*_' . $name));
            // argument must be string
            parent::assertFalse(PersonPosition::exists($position));
            parent::assertFalse(PersonPosition::exists(null));
        }
    }

    public function testDelete() {
        parent::markTestSkipped('in testCan_be_deleted, otherwise only DB fail');
    }

    public function testCan_be_deleted() {
        foreach ($this->all_positions as $position) {
            $team_members = StmFactory::find()->TeamMember->findByPosition($position);
            $club_members = array();
            $referees = array();
            $match_players = array();
            
            if (!empty($team_members)) {
                parent::assertFalse($position->canBeDeleted());                
            }
        }
    }

    public function testUpdate() {
        parent::markTestSkipped('test in PersonPositionValidatorTest::testCheck_update');
    }

}

?>
